function [GI_DispCrL,GI_NumCrL,GI_DateCrL,battANALOG,ATTIVA,FIG] = report_CrL_ENG(rCrL,...
    m,NodoCrackLink,toolrif,unitrif,contunit,datarif,Font_caption,...
    Font_tools,battANALOG,ATTIVA,siteID,DT,FIG,br,status,conn,FileName)

import mlreportgen.dom.*
import mlreportgen.report.*

% Make sure DOM is compilable
makeDOMCompilable()

GI_DispCrL = [];
GI_NumCrL = [];
GI_DateCrL = [];

if status(m,1) == 1
    if ATTIVA == 1
        testo = Paragraph('GMUX not installed or inactive.');
        add(DT,testo);
        ATTIVA = 0;
    end
elseif status(m,1) == 3
    if ATTIVA == 1
        testo = Paragraph(['Monitoring completed. Please log into the web-based platoform '...
            'to access the complete dataset.']);
        add(DT,testo);
        ATTIVA = 0;
    end
else
    CrE = Section();
    sezCrack = Heading3('Crack Link');
    sezCrack.Style = {OuterMargin('0in','0in','0.15in','0in'),FontSize(Font_tools),Bold(1),Italic(1)};
    CrE.Title = sezCrack;
    if battANALOG == 0
        comando = ['select Date, Time, UnitName, ToolNameID, BatLevel, Temperature from RawDataView where Date >= ''' ...
            datarif ''' and UnitName = ''' char(unitrif) ''' and ToolNameID = '''...
            char(toolrif) ''' and NodeNum = 1 '];
        curs = exec(conn,comando);
        curs = fetch(curs);
        BatTemp = curs.Data;
        [~,cc] = size(BatTemp);
        if cc ~= 1 %ci sono dati riferiti all'ultimo mese/periodo di interesse
            DataPlot = [BatTemp(:,1) BatTemp(:,2)];
            % sistemo date, batteria e temperatura
            [rD,~] = size(DataPlot);
            T = [cell2mat(DataPlot(:,1)) repmat(' ', [rD,1]) cell2mat(DataPlot(:,2))];
            Date = datenum(T);
            Batteria = cell2mat(BatTemp(:,5));
            Temperatura = cell2mat(BatTemp(:,6));
            
            % testo introduttivo
            testoB1 = Paragraph(['The following chart reports the battery level trend recorded during the reference time period. '...
                'The correct functioning of the GMUX module is guaranteed for a minimum level of 12 V. The last '...
                'available data is equal to ' num2str(Batteria(end,1)) ' V.']);
            testoB2 = Paragraph(['The GMUX module equips also a thermometer that allows the monitoring of the working '...
                'temperature and the identification of eventual malfunctioning. The following chart reports temperature '...
                'data recorded by the GMUX module.']);
            testoB1.HAlign = 'justify';
            testoB2.HAlign = 'justify';
            
            % grafico batteria
            figure(19)
            plot(Date,Batteria);
            hold on
            title('Battery level and GMUX temperature');
            xlabel('Date [dd/mm/yyyy]');
            ylabel('Level [V]');
            ylim([floor(min(Batteria(:,1))) ceil(max(Batteria(:,1)))]);
            
            yyaxis right
            GMUX = plot(Date,Temperatura,':','LineWidth',1.1);
            ylim([floor(min(Temperatura(:,1))) ceil(max(Temperatura(:,1)))]);
            ylabel(['Temperature [' char(176) 'C]']);
            set(gca,'YColor','k');
            str(1,1) = cellstr('Battery');
            str(2,1) = cellstr('Temperature');
            legend(str,'Location','northwest');
            h = gca;
            h.XAxis.MinorTick = 'on';
            datetick('x','dd/mm/yyyy','keepticks','keeplimits');
            xtickangle(20);
            grid on
            grid minor
            xlim([Date(1)-1 Date(end)+1]);
            
            TempName = char(strcat('Report',siteID,'-', contunit,'-GMUX_ENG.png'));
            saveas(GMUX,TempName);
            ChartGMUX = Image(TempName);
            ChartGMUX.Style = {Height('8cm'),HAlign('center')};
            if Batteria(end,1) >= 13
                TempName = char(strcat('B_13.jpg'));
            elseif Batteria(end,1) >= 12
                TempName = char(strcat('B_12.jpg'));
            elseif Batteria(end,1) >= 11
                TempName = char(strcat('B_11.jpg'));
            else
                TempName = char(strcat('B_10.jpg'));
            end
            Batt = Image(TempName);
            Batt.Style = {Height('4cm'),HAlign('center')};
            
            lot = Table({ChartGMUX, Batt});
            lot.TableEntriesStyle = {HAlign('center'),VAlign('middle')};
            lot.Style = {ResizeToFitContents(false),Width("100%")};
            grps(1) = TableColSpecGroup;
            grps(1).Span = 2;
            specs(1) = TableColSpec;
            specs(1).Span = 1;
            specs(1).Style = {Width("80%")};
            specs(2) = TableColSpec;
            specs(2).Span = 1;
            specs(2).Style = {Width("20%")};
            grps(1).ColSpecs = specs;
            lot.ColSpecGroups = grps;
            
            lot_cap = Paragraph(['Fig. ' num2str(FIG) ' - Battery level and GMUX temperature recorded '...
                'during the reference time period']);
            FIG = FIG+1;
            lot_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
            FIG = FIG+1;
            Chart_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
            Batt = Section();
            sezBATT = Heading3('GMUX - Battery level and temperature');
            sezBATT.Style = {FontSize(Font_tools),Bold(1),Italic(1)};
            Batt.Title = sezBATT;
            add(DT,sezBATT);
            add(DT,testoB1);
            add(DT,testoB2);
            add(DT,lot);
            add(DT,lot_cap);
            add(DT,br);
            close(figure(19));
            battANALOG = 1;
        end
    end
    add(DT,sezCrack);
    for cr = 1:rCrL(m,1)
        NodeNum = num2str(NodoCrackLink(cr,m));
        comando = ['select EventDate, EventTime, XShift from ElabDataView where EventDate >= ''' ...
            datarif ''' and  ToolNameID = ''' char(toolrif) ''' and UnitName = ''' char(unitrif) ...
            ''' and NodeNum = ''' NodeNum ''' '];
        curs = exec(conn,comando);
        curs = fetch(curs);
        Dati = curs.Data;
        % Modifico il formato di data e ora
        [rD,rC] = size(Dati);
        if rC ~= 1
            T = [cell2mat(Dati(:,1)) repmat(' ', [rD,1]) cell2mat(Dati(:,2))];
            Date = datenum(T); % Data
            open = cell2mat(Dati(:,3)); % Fessura
            dS = open-open(1);
            
            GI_DispCrL(:,cr) = open;
            GI_NumCrL(:,cr) = NodoCrackLink(cr,m);
            GI_DateCrL = Date;
            
            % grafico pressione atmosferica NELL'ULTIMO MESE
            figure(5);
            apertura = plot(Date,dS);
            title(['Opening/closing of the crack meter - node number ' NodeNum]);
            xlabel('Date [dd/mm/yyyy]');
            ylabel('Deformation [mm]');
            control = abs(max(dS)-min(dS));
            if control < 1
                varG = (1-control)/2;
                ylim([min(dS)-varG max(dS)+varG]);
            end
            xlim([Date(1)-1 Date(end)+1]);
            h = gca;
            h.XAxis.MinorTick = 'on';
            datetick('x','dd/mm/yyyy','keepticks','keeplimits');
            xtickangle(15);
            grid on
            grid minor
            
            hold off
            
            TempName = char(strcat('Report',siteID,'-', char(toolrif),'-Crack', NodeNum, '_ENG.png'));
            saveas(apertura,TempName);
            ChartCrL = Image(TempName);
            ChartCrL.Style = {Height('7.1cm'),HAlign('center')};
            ChartCrL_cap = Paragraph(['Fig. ' num2str(FIG) ' - Opening (increasing trend) and closing (decreasing trend) '...
                'over time, recorded by the crack meter, node number ' NodeNum ' ']);
            FIG = FIG+1;
            ChartCrL_cap.Style = {HAlign('center'),FontSize(Font_caption),Italic(1),Color('midnightblue')};
            
            if cr == 1
                testo = Paragraph(['The following graph reports deformation data recorded by the crack meter '...
                    'installed on site, represented as opening and/or closing of the monitoring tool. In particular, increasing '...
                    'values respresent a crack opening, while a decreasing trend corresponds to a closing behaviour.']);
                testo.HAlign = 'justify';
                add(DT,testo);
            end
            testo2 = Paragraph(['Durign the reference time period, node ' NodeNum ' recorded a maximum and minimum value '...
                'of absolute deformation equal to ' num2str(round(max(open),2), '%0.2f') ' mm and '...
                num2str(round(min(open),2), '%0.2f') ' mm respectively, with a '...
                'maximum variation of ' num2str(round(max(open),2)-round(min(open),2),'%0.2f') ' mm.' ]);
            testo2.HAlign = 'justify';
            add(DT,testo2);
            add(DT,ChartCrL);
            add(DT,ChartCrL_cap);
            if cr == rCrL(m,1)
                add(DT,br);
            end
            close(figure(19));
            close(figure(5));
            %pulisco variabili da riutilizzare per catena successiva
            clear open;
        else
            if ATTIVA == 1
                CrE = Section();
                sezCrack = Heading3('Crack Link');
                sezCrack.Style = {OuterMargin('0in','0in','0.15in','0in'),FontSize(Font_tools),Bold(1),Italic(1)};
                CrE.Title = sezCrack;
                add(DT,sezCrack);
                testo = Paragraph('No data available for the reference time period.');
                add(DT,testo);
                br = PageBreak();
                add(DT,br);
                ATTIVA = 0;
            end
        end
    end
    
    if isempty(GI_DispCrL) == 0
        ind = 1;
        if rCrL(m) > 1 % pił di un fessurimetro, prendo quello con max variazione
            for k = 1:rCrL(m)
                maxX(1,k) = max(GI_DispCrL(:,k)-GI_DispCrL(1,k));
                if k == 1
                    rif = maxX(1,1);
                end
                if  maxX(1,k) > rif
                    rif = maxX(1,k);
                    ind = k;
                end
            end
            GI_DispCrL = GI_DispCrL(:,ind);
            GI_NumCrL = GI_NumCrL(1,ind);
        end
    end
end

fileID = fopen(FileName,'a');
fmt = '%s \r';
text = 'report_CrL_ENG function executed correctly';
fprintf(fileID,fmt,text);
fclose(fileID);

end